------------------------------------------------------
-- Levelator.lua
------------------------------------------------------

function FLV_OnEvent(self, inEvent)
	if (inEvent == "GOSSIP_SHOW") then
		FLV_ButtonIndex = 1;
		FLV_UpdateGossipQuests(GetGossipAvailableQuests());
		if (GetNumGossipAvailableQuests() > 0) then
			FLV_ButtonIndex = FLV_ButtonIndex + 1;
		end
		FLV_UpdateGossipQuests(GetGossipActiveQuests());
	elseif (inEvent == "QUEST_GREETING") then
		for i = 1, GetNumActiveQuests() do
			local level = GetActiveLevel(i);
			local title = GetActiveTitle(i);
			local button = getglobal("QuestTitleButton"..i);
			if ( IsActiveQuestTrivial(i) ) then
				button:SetFormattedText(FLV_GetLowLevelQuestColor()..'[%d] %s'..FONT_COLOR_CODE_CLOSE, level, title);
			else
				button:SetFormattedText('[%d] %s', level, title);
			end
		end
		for i = 1, GetNumAvailableQuests() do
			local level = GetAvailableLevel(i);
			local title = GetAvailableTitle(i);
			local button = getglobal("QuestTitleButton"..i + (GetNumActiveQuests() or 0));
			button:SetFormattedText('[%d] %s', level, title);
			if ( IsAvailableQuestTrivial(i) ) then
				button:SetFormattedText(FLV_GetLowLevelQuestColor()..'[%d] %s'..FONT_COLOR_CODE_CLOSE, level, title);
			else
				button:SetFormattedText('[%d] %s', level, title);
			end
		end
	end
end

function FLV_UpdateGossipQuests(...)
	for i = 1, select("#", ...), 3 do
		local button = getglobal("GossipTitleButton"..FLV_ButtonIndex);
		if ( select(i+2, ...) ) then
			button:SetFormattedText(FLV_GetLowLevelQuestColor()..'[%d] %s'..FONT_COLOR_CODE_CLOSE, select(i+1, ...), select(i, ...));
		else
			button:SetFormattedText('[%d] %s', select(i+1, ...), select(i, ...));
		end
		GossipResize(button);
		FLV_ButtonIndex = FLV_ButtonIndex + 1;
	end
end

function FLV_GetLowLevelQuestColor()
	if (not FLV_LowLevelQuestColor) then
	local c = MATERIAL_TEXT_COLOR_TABLE.Default;
		FLV_LowLevelQuestColor = string.format("|cff%02x%02x%02x", (c[1] * 255), (c[2] * 255), (c[3] * 255));
	end
	return FLV_LowLevelQuestColor;
end

function FLV_AnnotateTitle(title, level, tag, numPlayers, isHeader, ...)
	if (title and not isHeader) then
		local prefix;
		if (tag and numPlayers > 0) then
			prefix = "["..level..string.sub(tag, 1, 1)..numPlayers.."]";
		elseif (tag) then
			prefix = "["..level..string.sub(tag, 1, 1).."]";
		else
			prefix = "["..level.."]";
		end	
		return prefix .. title, level, tag, numPlayers, isHeader, ...;
	else
		return title, level, tag, numPlayers, isHeader, ...;
	end
end

function FLV_GetQuestLogTitle(questIndex)
	return FLV_AnnotateTitle(FLV_Orig_GetQuestLogTitle(questIndex));
end

function FLV_GameTooltip_SetHyperlink(tooltip, link)
	tooltip:Orig_SetHyperlink(link);
	if (link) then
		local _, _, questLevel, title = string.find(link, "quest:%d+:(%d+)");
		if (questLevel) then
			local leftText = getglobal(tooltip:GetName().."TextLeft1");
			local title = leftText:GetText();
			if (title) then
				leftText:SetText(format("[%d] %s", questLevel, title));
			end
		end
	end
end

FLV_EventFrame = CreateFrame("Frame", nil, nil);
FLV_EventFrame:SetScript("OnEvent", FLV_OnEvent);
FLV_EventFrame:RegisterEvent("GOSSIP_SHOW");
FLV_EventFrame:RegisterEvent("QUEST_GREETING");

FLV_Orig_GetQuestLogTitle = GetQuestLogTitle;
GetQuestLogTitle = FLV_GetQuestLogTitle;

GameTooltip.Orig_SetHyperlink = GameTooltip.SetHyperlink;
GameTooltip.SetHyperlink = FLV_GameTooltip_SetHyperlink;
ItemRefTooltip.Orig_SetHyperlink = ItemRefTooltip.SetHyperlink;
ItemRefTooltip.SetHyperlink = FLV_GameTooltip_SetHyperlink;

